
ZBTOOLSVERSION  =1
#include "ti83plus.inc" ;File needed to access system routines
.org userMem-2          ;Define where to start in memory
.db $BB,$6D             ;AsmPrgm instruction

    bcall(_rclx)
    bcall(_convop1)
    cp 1        ;ZBTools Version, N=Version
    jr z,zbtver
    cp 2        ;Calc off
    jr z,off
    cp 3        ;Clear the screen, FAST!
    jr z,clrscr
    cp 4        ;Run Indicator, N=1=On, N=0=Off
    jr z,runi
    cp 5        ;Lowercase, N=1=On, N=0=Off
    jp z,lowerc
    cp 6        ;Fast Circles, N=1=On, N=0=Off
    jp z,circles
    cp 7        ;Alpha lock on
    jp z,alphaon
    cp 8        ;Free Mem in N
    jp z,FreeMem
    cp 9        ;Inverse Screen
    jp z,inversescr
    cp 10        ;Blacken Screen, FAST!
    jp z,blackscr
    cp 11       ;Text Inverse, N=1=On, N=0=Off
    jp z,inversetxt
    cp 12       ;Batt Check, N=1=Need replace, N=0=OK
    jp z,bttchk
    cp 13       ;TI-OS ver to N/M exe: 1.15 = (N=1)(M=15)
    jp z,osver
    cp 14       ;Contrast, N=0-39=Contrast, N=40=Reset
    jp z,changecontrast
    cp 15       ;Kill 'Done', Use at end of prgm to kill 'Done' (same effect as 'Output(1,1,"' at end)
    jp z,killdone
    ret
    
zbtver:
    ld a,ZBTOOLSVERSION
    call StoN
    ret
    
off:
    ld a,1    
    out (3),a    
    halt
    res onInterrupt, (IY + onFlags)
    ret

clrscr: ;FAST!!!! routine courtesy of TI-83 Plus Assembly In 28 Days
    DI
    LD  (save_SP),SP
    LD  SP,PlotSScreen+768  ; 768 byte area
    LD  HL,$0000
    LD  B,48        ; PUSH 48*8=384 times, @ 2 bytes a PUSH = 768
loopclr:
    PUSH    HL      ; Do multiple PUSHes in the loop to save cycles on DJNZ
    PUSH    HL
    PUSH    HL
    PUSH    HL
    PUSH    HL
    PUSH    HL
    PUSH    HL
    PUSH    HL
    DJNZ    loopclr
    LD  SP,(save_SP)
    EI
    b_call(_GrBufCpy)
    RET
save_SP:
    .DB 0,0

runi:
    call rcln
    cp 0
    jr z,runioff
    cp 1
    jr z,runion
    ret
runioff:
    res indicRun,(IY + indicFlags)
    ret
runion:
    set indicRun,(IY + indicFlags)
    ret
    
lowerc:
    call rcln
    cp 0
    jr z,loweroff
    cp 1
    jr z,loweron
    ret
loweroff:
    res LwrCaseActive,(IY + AppLwrCaseFlag)
    ret
loweron:
    set LwrCaseActive,(IY + AppLwrCaseFlag)
    ret
    
circles:
    call rcln
    cp 0
    jr z,slowcircles
    cp 1
    jr z,fastcircles
    ret
slowcircles:
    res UseFastCirc,(IY + PlotFlag3)
    ret
fastcircles:
    set UseFastCirc,(IY + PlotFlag3)
    ret

AlphaOn:
    res ShiftLwrAlph,(IY + ShiftFlags)
    set ShiftAlpha,(IY + ShiftFlags)
    set ShiftALock,(IY + ShiftFlags)
    ret
    
FreeMem:
    bcall(_MemChk)
    bcall(_setxxxxop2)
    bcall(_op2toop1)
    call stoop1n
    ret

InverseScr:
    ld hl,0
    ld de,3f5fh
    bcall(_invertrect)
    ret
    
BlackScr:
    DI
    LD  (save_SP),SP
    LD  SP,PlotSScreen+768  ; 768 byte area
    LD  HL,$FFFF
    LD  B,48        ; PUSH 48*8=384 times, @ 2 bytes a PUSH = 768
loopBlack:
    PUSH    HL      ; Do multiple PUSHes in the loop to save cycles on DJNZ
    PUSH    HL
    PUSH    HL
    PUSH    HL
    PUSH    HL
    PUSH    HL
    PUSH    HL
    PUSH    HL
    DJNZ    loopBlack
    LD  SP,(save_SP)
    EI
    b_call(_GrBufCpy)
    RET
    
InverseTxt:
    call rcln
    cp 0
    jr z,itxtoff
    cp 1
    jr z,itxton
    ret
itxtoff:
    res TextInverse,(IY + TextFlags)
    ret
itxton:
    set TextInverse,(IY + TextFlags)
    ret
    
bttchk:
    bcall(_Chk_Batt_Low)
    jr z,lowbatt
    jr nz,okbatt
    ret
lowbatt:
    ld a,1
    call ston
    ret
okbatt:
    ld a,0
    call ston
    ret
    
osver:
    bcall(_GetBaseVer)
    push af
    ld a,b
    call stoM
    pop af
    call stoN
    ret
    
changeContrast:
    call rclN
    cp 40
    jr z,rescontrast
setconta:
;Set contrast to value in A
;Valid range: 0 - 27h
    DI
    LD B,A
    CP 28h
    JR NC,contrast_is_invalid 
    push af
    push af
    pop af
    pop af
    add a,18h
    OR 0C0h
    out (lcdinstport),A
contrast_is_invalid:
    ei
    ret
rescontrast:
    ld a,(contrast)
    jr setconta
    
killdone:
    res DonePrgm,(IY + DoneFlags)
    ret
    
    
rclACC: ;var 'ACC' to ACC
    push af
    bcall(_zeroop1)
    ld hl,op1+1
    pop af
    ld (hl),a
    bcall(_rclvarsym)
    bcall(_convop1)
    ret
rcln:   ;var N to ACC
    bcall(_zeroop1)
    ld hl,op1+1
    ld (hl),'N'
    bcall(_rclvarsym)
    bcall(_convop1)
    ret
ston:   ;var ACC to N
    bcall(_setxxop1)
    bcall(_pushrealO1)
    bcall(_zeroop1)
    ld hl,'N'
    ld (op1+1),hl
    bcall(_stoother)
    ret
rclm:   ;var M to ACC
    bcall(_zeroop1)
    ld hl,op1+1
    ld (hl),'M'
    bcall(_rclvarsym)
    bcall(_convop1)
    ret
stom:   ;var ACC to M
    bcall(_setxxop1)
    bcall(_pushrealO1)
    bcall(_zeroop1)
    ld hl,'M'
    ld (op1+1),hl
    bcall(_stoother)
    ret
stox:   ;var ACC to X
    bcall(_setxxop1)
    bcall(_stoX)
    ret
stoop1n:;var OP1 to N
    bcall(_pushrealO1)
    bcall(_zeroop1)
    ld hl,'N'
    ld (op1+1),hl
    bcall(_stoother)
    ret
rclx:   ;var X to ACC
    bcall(_rclX)
    bcall(_convop1)
    ret

.end                    ;End of code